package fr.inria.indes.ggmm;

import fr.inria.bps.base.Liste;
import fr.inria.bps.base.Pair;
import fr.inria.indes.ggmm.expr.Ident;
import fr.inria.indes.ggmm.expr.Ref;
import fr.inria.indes.ggmm.expr.Tid;

public class MopConfig {
    public Configuration conf;
    public boolean done = false;
    public Tid thread;
    public Liste<Pair<Tid,Mop>> before;
    public Liste<Pair<Tid,Mop>> after;
    public Liste<Pair<Tid,Mop>> res;

    public MopConfig(Configuration conf, Tid t, Mop mop, Liste<Pair<Tid, Mop>> after, Liste<Pair<Tid, Mop>> before) {
	this.conf = conf;
	this.thread = t;
	this.after = after;
	this.before = before;
    }
    
    public void commit() {
	setRes(before, after);
    }
    
    public void setRes(Liste<Pair<Tid,Mop>> before, Liste<Pair<Tid,Mop>> after) {
	res = (Liste.appendrev(after, before));
	done = true;
    }
    
    public void substIdent(Ident nu, Value v) {
	// conf.S = substIdentStore(nu, v, conf.S);
	conf.T = substIdentThreads(nu, v, conf.T);
	setRes(substIdentTStore(nu, v, before), substIdentTStore(nu, v, after));
    }
    
    public static Liste<Pair<Tid,Expression>> substIdentThreads(Ident nu, Value v, Liste<Pair<Tid,Expression>> l) {
	if(l == null) return(l);
	return(Liste.cons(Pair.cons(l.car.car, l.car.cdr.substIdent(nu, v)), substIdentThreads(nu, v, l.cdr)));
    }
    
    public static Liste<Pair<Ref,Value>> substIdentStore(Ident nu, Value v, Liste<Pair<Ref,Value>> l) {
	if(l == null) return(l);
	return(Liste.cons(Pair.cons(l.car.car, (Value) l.car.cdr.substIdent(nu, v)), substIdentStore(nu, v, l.cdr)));
    }
    
    public static Liste<Pair<Tid,Mop>> substIdentTStore(Ident nu, Value v, Liste<Pair<Tid,Mop>> l) {
	if(l == null) return(l);
	return(Liste.cons(Pair.cons(l.car.car, l.car.cdr.substIdent(nu, v)), substIdentTStore(nu, v, l.cdr)));
    }
}
