package fr.inria.indes.ggmm;

import fr.inria.bps.base.Liste;
import fr.inria.bps.base.Pair;
import fr.inria.indes.ggmm.expr.Ref;

public class Result {
    public String strategy;
    public int nbNodes;
    public Path[] results;
    public long time;
    
    public Result(String strategy, int nbNodes, Path[] results, long time) {
	this.strategy = strategy;
	this.nbNodes = nbNodes;
	this.results = results;
	this.time = time;
    }
    
    public boolean has(String[][] store) {
	for( Path p : results ) {
	    Liste<Configuration> l = p.path;
	    if(l == null) throw(new RuntimeException("null path " + p));
	    if(storeInclude(l.car.S, store)) return(true);
	}
	return(false);
    }
    
    static boolean storeInclude(Liste<Pair<Ref,Value>> store, String[][] slots) {
	for( String[] slot : slots )
	    if(!storeHas(store, slot[0], slot[1])) return(false);
	return(true);
    }
    
    static boolean storeHas(Liste<Pair<Ref,Value>> store, String name, String value) {
	for(Liste<Pair<Ref,Value>> s = store; s != null; s = s.cdr)
	    if(name.equals(s.car.car.id))
		return(value.equals(s.car.cdr.toString()));
	throw(new RuntimeException("store " + store + " not have the reference " + name));
    }
 
    public void dump(int level) {
	System.out.println(toString());
	int n = results.length;
	if(level > 0) for(int i=0; i<n; i++) results[i].dump(level-1);
    }
    public String toString() {
	return(nbNodes+" nodes\t"+results.length+" results\tdone in "+time+" ms.");
    }
}
