package fr.inria.indes.ggmm;

import fr.inria.bps.base.Liste;
import fr.inria.bps.base.Pair;
import fr.inria.indes.ggmm.expr.Tid;

public class StepResult {
    public enum Kind {
        EXPR_RESULT,
        STUCK_NOTREF, STUCK_NOTFUN, STUCK_NOTTHREAD, STUCK_NOTBOOL,
        WAIT_JOIN, WAIT_WITH, WAIT_VAL, 
    }
    
    public Configuration conf;
    public Kind kind;
    public Expression res = null;
    public Tid t;
    // The main expression, need for WithDo
    public Expression todo;
    public Liste<Pair<Tid, Expression>> left;
    public Liste<Pair<Tid, Expression>> right;
    
    public StepResult(Configuration conf, Tid t, Expression todo, Liste<Pair<Tid, Expression>> left, Liste<Pair<Tid, Expression>> right) {
	this.conf = conf;
	this.t = t;
	this.todo = todo;
	this.left = left;
	this.right = right;
    }

    public void addPipe(Mop m) {
	conf.sigma = Liste.cons(Pair.cons(t, m), conf.sigma);
    }
}
