package fr.inria.indes.ggmm.expr;

import java.util.Vector;

import fr.inria.indes.ggmm.Expression;
import fr.inria.indes.ggmm.Value;

public class Abs extends SyntacticValue {
    public Var var;
    public Expression body;
    
    public Abs(Var var, Expression body) {
	this.var = var;
	this.body = body;
    }

    public Expression subst(Var v, Value e) {
	// CARE this is not the capture avoiding substitution ...
	if(v == var) return(this);
	return(new Abs(var, body.subst(v, e)));
    }

    public  Expression substIdent(Ident id, Value v) {
	return(new Abs(var, body.substIdent(id, v)));
    }
   
    public boolean hasIdent() {
	return(body.hasIdent());
    }

    public void getRefs(Vector<Ref> v) {
	body.getRefs(v);
    }

    public String toString() {
	return("(lambda " + var + " " + body + ")");
    }
}
