package fr.inria.indes.ggmm.expr;

import java.util.Vector;

import fr.inria.bps.base.Liste;
import fr.inria.indes.ggmm.Expression;
import fr.inria.indes.ggmm.StepResult;
import fr.inria.indes.ggmm.Value;
import fr.inria.indes.ggmm.mop.Wr;

public class Affect extends Expression {
    public Value dest;
    public Value src;
    private boolean novisib;
    
    public Affect(Value dest, Value src, boolean fast) {
	this.dest = dest;
	this.src = src;
	this.novisib = fast;
    }

    public boolean hasIdent() {
	return(dest.hasIdent() || src.hasIdent());
    }

    public void getRefs(Vector<Ref> v) {
	dest.getRefs(v);
	src.getRefs(v);
    }
 
    public Expression subst(Var v, Value e) {
	return(new Affect((Value) dest.subst(v, e), (Value) src.subst(v, e), novisib));
    }

    public Expression substIdent(Ident id, Value v) {
	return(new Affect((Value) dest.substIdent(id, v), (Value) src.substIdent(id, v), novisib));
   }

    public void dostep(StepResult r) {
	if(!(dest instanceof Ref || dest instanceof Ident)) {
	    r.kind = StepResult.Kind.STUCK_NOTREF;
	    return;
	}
	if(novisib) {
	    r.addPipe(new Wr(dest, src, null, null));
	} else {
	    r.addPipe(new Wr(dest, src));
	}
	r.res = Void.nil;
    }

    public void dorefstep(StepResult r) {
	if(!(dest instanceof Ref)) {
	    r.kind = StepResult.Kind.STUCK_NOTREF;
	    return;
	}
	Ref p = (Ref) dest;
	r.conf.S = Liste.setassq(r.conf.S, p, src);
	r.res = Void.nil;
    }

    public String toString() {
	return(dest + " := " + src);
    }
}
