package fr.inria.indes.ggmm.expr;

import java.util.Vector;

import fr.inria.bps.base.Liste;
import fr.inria.indes.ggmm.Configuration;
import fr.inria.indes.ggmm.Expression;
import fr.inria.indes.ggmm.StepResult;
import fr.inria.indes.ggmm.Value;
import fr.inria.indes.ggmm.mop.Rd;

public class DeRef extends Expression {
    public String identName;
    public Value value;

    public DeRef(String identName, Value value) {
	this.identName = identName;
	this.value = value;
    }
    
    String identName(StepResult r) {
//	return((identName != null) ? identName : (""+r.conf.refident++));
	return((identName != null) ? identName : (""+Configuration.counter++));
    }

    public boolean hasIdent() {
	return(value.hasIdent());
    }

    public void getRefs(Vector<Ref> v) {
	value.getRefs(v);
    }
 
    public Expression subst(Var v, Value e) {
	return(new DeRef(identName, (Value) value.subst(v, e)));
    }

    public Expression substIdent(Ident id, Value v) {
	return(new DeRef(identName, (Value) value.substIdent(id, v)));
    }

    public void dostep(StepResult r) {
	if(!(value instanceof Ref || value instanceof Ident)) {
	    r.kind = StepResult.Kind.STUCK_NOTREF;
	    return;
	}
	Ident res = new Ident(identName(r));
	r.addPipe(new Rd(value, res));
	r.res = res;
    }

    public void dorefstep(StepResult r) {
	if(!(value instanceof Ref)) {
	    r.kind = StepResult.Kind.STUCK_NOTREF;
	    return;
	}
	Ref p = (Ref) value;
	Value res = Liste.cassq(r.conf.S, p);
	if(res == null) throw(new RuntimeException("Invalid store " + p));
	r.res = res;
    }
    
    public String toString() {
	return("!" + value);
    }
}
