package fr.inria.indes.ggmm.expr;

import java.util.Vector;

import fr.inria.bps.base.Liste;
import fr.inria.bps.base.Pair;
import fr.inria.indes.ggmm.Configuration;
import fr.inria.indes.ggmm.Expression;
import fr.inria.indes.ggmm.StepResult;
import fr.inria.indes.ggmm.Value;
import fr.inria.indes.ggmm.mop.Wr;

public class MakeRef extends Expression {
    private String refName = null;
    public Value value;
    
    public MakeRef(Value value) {
	this.value = value;
    }
    
    public MakeRef(String refName, Value value) {
	this.refName = refName;
	this.value = value;
    }
 
    public boolean hasIdent() {
	return(value.hasIdent());
    }

    public void getRefs(Vector<Ref> v) {
	value.getRefs(v);
    }
  
    public Expression subst(Var v, Value e) {
	return(new MakeRef(refName, (Value) value.subst(v, e)));
    }

    public Expression substIdent(Ident id, Value v) {
	return(new MakeRef(refName, (Value) value.substIdent(id, v)));
    }
    
    String refName(StepResult r) {
//	return((refName != null) ? refName : (""+r.conf.refid++));
	return((refName != null) ? refName : (""+Configuration.counter++));
    }

    public void dostep(StepResult r) {
	Ref res = new Ref(refName(r));
	//r.conf.S = Liste.cons(Pair.cons(res, ((Val) Void.nil)), r.conf.S);
	r.addPipe(new Wr(res, value));
	r.res = res;
    }
    
    public void dorefstep(StepResult r) {
	Ref res = new Ref(refName(r));
	r.conf.S = Liste.cons(Pair.cons(res, value), r.conf.S);
	r.res = res;
    }
    
    public String toString() {
	return("(ref " + value + ")");
    }
}
