package fr.inria.indes.ggmm.expr;

import java.util.Vector;

import fr.inria.bps.base.Liste;
import fr.inria.bps.base.Pair;
import fr.inria.indes.ggmm.Configuration;
import fr.inria.indes.ggmm.Expression;
import fr.inria.indes.ggmm.StepResult;
import fr.inria.indes.ggmm.Value;
import fr.inria.indes.ggmm.mop.Spw;

public class MakeThread extends Expression {
    Expression expr;

    public MakeThread(Expression expr) {
	this.expr = expr;
    }

    public boolean hasIdent() {
	return(expr.hasIdent());
    }

    public void getRefs(Vector<Ref> v) {
	expr.getRefs(v);
    }
  
    public Expression subst(Var v, Value e) {
	return(new MakeThread(expr.subst(v, e)));
    }

    public Expression substIdent(Ident id, Value v) {
	return(new MakeThread(expr.substIdent(id, v)));
   }

    public void dostep(StepResult r) {
//	Tid nid = new Tid(r.conf.reftid++);
	Tid nid = new Tid(Configuration.counter++);
	r.addPipe(new Spw(nid, expr));
	r.res = nid;
    }

    public void dorefstep(StepResult r) {
//	Tid nid = new Tid(r.conf.reftid++);
	Tid nid = new Tid(Configuration.counter++);
	r.right = new Liste<Pair<Tid,Expression>>(new Pair<Tid,Expression>(nid, expr), r.right);
	r.res = nid;
    }
    
    public String toString() {
	return("(thread " + expr + ")");
    }
}
