package fr.inria.indes.ggmm.expr;

import java.util.Vector;

import fr.inria.bps.base.Liste;
import fr.inria.indes.ggmm.Expression;
import fr.inria.indes.ggmm.StepResult;
import fr.inria.indes.ggmm.Value;
import fr.inria.indes.ggmm.mop.Release;

public class Protected extends Expression {
    public Expression todo;
    public Ref lock;
    
    public Protected(Expression todo, Ref lock) {
	this.todo = todo;
	this.lock = lock;
    }
    
    public boolean hasIdent() {
	return(lock.hasIdent() || todo.hasIdent());
    }

    public void getRefs(Vector<Ref> v) {
	todo.getRefs(v);
	lock.getRefs(v);
    }
  
    public Expression subst(Var v, Value e) {
	return(new Protected(todo.subst(v, e), lock));
    }

    public Expression substIdent(Ident id, Value v) {
	return(new Protected(todo.substIdent(id, v), lock));
    }

    public void dostep(StepResult r) {
	if(!(todo instanceof Value)) {
	    todo.dostep(r);
	    if(r.res == null) return;
	    r.res = new Protected(r.res, lock);
	    return;
	}
	r.addPipe(new Release(lock));
	r.res = todo;
    }

    public void doextrastep(StepResult r) {
	if(!(todo instanceof Value)) {
	    todo.doextrastep(r);
	    if(r.res == null) return;
	    r.res = new Protected(r.res, lock);
	    return;
	}
    }

    public void dorefstep(StepResult r) {
	if(!(todo instanceof Value)) {
	    todo.dorefstep(r);
	    if(r.res == null) return;
	    r.res = new Protected(r.res, lock);
	    return;
	}
	r.conf.O = Liste.remassq(r.conf.O, lock);
	r.res = todo;
    }
    
    public String toString() {
	return(todo + "\\" + lock);
    }
}
