package fr.inria.indes.ggmm.mop;

import fr.inria.bps.base.Liste;
import fr.inria.bps.base.Pair;
import fr.inria.indes.ggmm.MemoryModel;
import fr.inria.indes.ggmm.Mop;
import fr.inria.indes.ggmm.MopConfig;
import fr.inria.indes.ggmm.expr.Ident;
import fr.inria.indes.ggmm.expr.Ref;
import fr.inria.indes.ggmm.expr.Tid;

public class Acquire extends Sync {
    public Ref ref;
    
    public Acquire(Ref ref) {
	this.ref = ref;
    }

    public void step(MopConfig r) {
	Tid own = Liste.cassq(r.conf.O, ref);
	if(own != null) return;
	if(MemoryModel.current.commutability(r.conf, r.before, Pair.cons(r.thread, (Mop)this))) {
	    r.conf.O = Liste.cons(Pair.cons(ref, r.thread), r.conf.O);
	    r.commit();
	    return;
	}
   }

    public boolean strict(Mop mop) {
	if(mop instanceof Rd) {
	    Rd rd = (Rd) mop;
	    return((ref == rd.rho) || (rd.rho instanceof Ident));
	}
	if(mop instanceof Release) {
	    Release r = (Release) mop;
	    return(ref == r.ref);
	    
	}
	if(mop instanceof Spw) return(true);
	return(false);
	
    }

    public String toString() {
	return("-" + ref + "->");
    }
}
