package fr.inria.indes.ggmm.mop;

import fr.inria.bps.base.Pair;
import fr.inria.indes.ggmm.MemoryModel;
import fr.inria.indes.ggmm.Mop;
import fr.inria.indes.ggmm.MopConfig;
import fr.inria.indes.ggmm.Value;
import fr.inria.indes.ggmm.expr.Ident;

public class Guess extends Mop {
    public Ident orig;
    public Value ident;
    Value value;
    
    private Guess(Ident orig, Value ident, Value value) {
	this.orig = orig;
	this.ident = ident;
	this.value = value;
    }
    
    public Guess(Ident ident, Value value) {
	this(ident, ident, value);
    }

    public void step(MopConfig r) {
	if(MemoryModel.current.commutability(r.conf, r.before, Pair.cons(r.thread, (Mop)this)) && (ident == value))
	    r.commit();
    }

    public boolean strict(Mop mop) {
	if(mop instanceof Wr) return(true);
	return(false);
    }
    
    public Mop substIdent(Ident id, Value v) {
	return(new Guess(orig, ident == id ? v : ident, value));
    }
    
    public String toString() {
	return("["+ident+"="+value+"]_"+orig);
    }
}
