package fr.inria.indes.ggmm.mop;

import fr.inria.bps.base.Liste;
import fr.inria.bps.base.Pair;
import fr.inria.indes.ggmm.MemoryModel;
import fr.inria.indes.ggmm.Mop;
import fr.inria.indes.ggmm.MopConfig;
import fr.inria.indes.ggmm.Value;
import fr.inria.indes.ggmm.expr.Ident;
import fr.inria.indes.ggmm.expr.Tid;

public class RdMark extends Mop {
    public Ident from;
    
    public RdMark(Ident from) {
	this.from = from;
    }

    public Mop substIdent(Ident id, Value val) {
	return(this);
    }

    public void step(MopConfig r) {
	if(MemoryModel.current.commutability(r.conf, r.before, Pair.cons(r.thread, (Mop)this))) {
	    // Rule R3 (read) part I
	    r.commit();
	} else {
	    // Rule R3 (read) part II
	    Liste<Pair<Tid,Mop>> l = r.before;
	    Liste<Pair<Tid,Mop>> d1 = null;
	    for( ; l != null ; l=l.cdr) {
		Mop mop = l.car.cdr;
		if(mop instanceof Wr && ((Wr) mop).hasReaden(this)) {
		    if(!MemoryModel.current.commutability(r.conf, l.cdr, l.car)) return;
		    r.commit();
		    return;
		} else {
		    d1 = Liste.cons(l.car, d1);
		}
	    }
	}
    }

    public boolean strict(Mop mop) {
	if(mop instanceof Spw) return(true);
	return(false);	
    }

    public String toString() {
	return("readMark_"+from);
    }

}
