package fr.inria.indes.ggmm.mop;

import fr.inria.bps.base.Liste;
import fr.inria.bps.base.Pair;
import fr.inria.indes.ggmm.MemoryModel;
import fr.inria.indes.ggmm.Mop;
import fr.inria.indes.ggmm.MopConfig;
import fr.inria.indes.ggmm.expr.Ident;
import fr.inria.indes.ggmm.expr.Ref;

public class Release extends Sync {
    public Ref ref;
    
    public Release(Ref ref) {
	this.ref = ref;
    }

    public void step(MopConfig r) {
	if(MemoryModel.current.commutability(r.conf, r.before, Pair.cons(r.thread, (Mop)this))) {
	    r.conf.O = Liste.remassq(r.conf.O, ref);
	    r.commit();
	    return;
	}
   }

    public boolean strict(Mop mop) {
	if(mop instanceof Wr) {
	    Wr wr = (Wr) mop;
	    return((ref == wr.rho) || (wr.rho instanceof Ident));
	}
	if(mop instanceof Acquire) {
	    Acquire r = (Acquire) mop;
	    return(ref == r.ref);
	    
	}
	if(mop instanceof Spw) return(true);
	return(false);
	
    }


    public String toString() {
	return("<-" + ref + "-");
    }
}
