package fr.inria.indes.ggmm.mop;

import fr.inria.bps.base.Liste;
import fr.inria.bps.base.Pair;
import fr.inria.indes.ggmm.Expression;
import fr.inria.indes.ggmm.MemoryModel;
import fr.inria.indes.ggmm.Mop;
import fr.inria.indes.ggmm.MopConfig;
import fr.inria.indes.ggmm.expr.Tid;

public class Spw extends SyncPlus {
    public Tid tid;
    public Expression expr;
    
    public Spw(Tid tid, Expression expr) {
	this.tid = tid;
	this.expr = expr;
    }

    public void step(MopConfig r) {
	if(MemoryModel.current.commutability(r.conf, r.before, Pair.cons(r.thread, (Mop)this))) {
	    r.conf.T = Liste.cons(Pair.cons(tid, expr), r.conf.T);
	    r.commit();
	    return;
	}
   }

    public boolean strict(Mop mop) {
	if(mop instanceof Spw) return(true);
	return(false);	
    }

    public String toString() {
	return("spw_" + tid + ",...");
    }
}
